<div class="style-border">
    <h4>Mon Test Abjaou</h4>
     
  <app-test-user-coding ></app-test-user-coding>
  <h4>tt {{ title1 }}</h4>
  <table class="table table-hover">
    <thead>
      <tr class="table-warning">
        <th scope="col">Id</th>
        <th scope="col">Nom</th>
        <th scope="col">Prénom</th>
        <th scope="col">Age</th>
        <th scope="col">Emotion</th>
      </tr>
    </thead>
    <tbody>
      <tr class="table-primary" *ngFor="let employe of listeEmploye; let i=index" >
        <td>{{i+1}}</td>
        <td>{{employe?.nom}}</td>
        <td>{{employe?.prenom}}</td>
        <td *ngIf="employe?.age !==0; else other">{{employe?.age}}</td>
        <ng-template #other>
            <td>Age non renseigné</td>
        </ng-template>
         <td [ngSwitch]="employe?.emotion">
          <span *ngSwitchCase="'happy'">:)</span>
          <span *ngSwitchCase="'sad'">:(</span>
          <span *ngSwitchDefault>:Id</span>
         </td>
        <!-- <td *ngIf="employe.emotion == happy">:)</td>
        <td *ngIf="employe.emotion == sad">:)</td> -->
      </tr>
    </tbody>
  </table>



  <h4>{{ title2 }}</h4>
  <table class="table table-hover">
      <thead>
        <tr class="table-warning">          
          <th scope="col">Nom</th>
          <th scope="col">Prénom</th>
          <th scope="col">Age</th>         
        </tr>
      </thead>
      <tbody>
        <tr *ngFor="let emp of listeEmploye" 
        [ngClass]="{'table-success': emp?.age < 20,
                   'table-danger': emp?.age > 30}">
                   
        <td>{{emp.nom}}</td>
        <td  [ngStyle]="{'color': emp?.prenom?.length > 4 ? 'green' : 'red'}">{{emp?.prenom}}</td>
        <td  [ngClass]="getColor(emp?.age)">{{emp?.age}}</td>
        </tr>
      </tbody>
    </table>

<div>
    <h4>{{ title3 }}</h4>
    <h5>Du controlerur vers la template</h5>
    <p>{{nom}}
    </p>

    <h5>De la template vers le controleur</h5>
    <button type="button" class="btn btn-primary" (click)='onAction()'> Button</button>
  <br>
  <br>
    <input type="text" style="width: 300px" [value]="nom" disabled>

    <!-- <p>{{nom}}
    </p> -->
  </div>
    <div>

    <h5>De la template vers le controleur</h5>
    <input type="text" [(ngModel)]="myFirstName" style="width: 300px">
    <!-- to way biding : je change il change automatiquement, il est utilisé généralement dans les formulaire -->
    <br>
    <br>
    <input type="text" style="width: 300px" [value]="myFirstName" disabled>
    <!-- <p>{{myFirstName}}
      </p> -->
    </div>

      <h4>{{ title4 }}</h4>
      <app-list-employe [listeemployesToBind]="listeEmploye"></app-list-employe>

      <h4>{{ title5 }}</h4>
      <div class="style-border">
          <h5>DAte pipe prédéfinie</h5>
          <p>Aujourd'hui c'est : <b>{{todayDate | date}}</b></p>
          <p>Aujourd'hui c'est : <b>{{todayDate | date: "dd-MM-yyyy"}}</b></p>
          <p>Aujourd'hui c'est : <b>{{todayDate | date: "jour: dd 'mois:' MM 'années: 'yyyy"}}</b></p>
          <p>Aujourd'hui c'est : <b>{{todayDate | date: "shortDate"}}</b></p> 
          <p>Aujourd'hui c'est : <b>{{todayDate | date: "fullDate"}}</b></p> 
          <p>Aujourd'hui c'est : <b>{{todayDate | date: "fullDate" | uppercase}}</b></p>
          <p>Aujourd'hui c'est : <b>{{todayDate | date: "fullDate" | uppercase | uppercase | lowercase}}</b></p>
          
          <h5>Pipe personnalisé</h5>
          <p><b>exemple 1  : </b>Pipe personnalisé de multiplication  (3*3) = {{3 | multiplicatPipe:3}}</p>
          <p><b>exemple 2  : </b>Pipe personnalisé de puissance </p>
          <input type="number" (keypress)="numberOnly($event)" style="width: 300px" [(ngModel)]="myPuissanceNumber"><br><br>
          <input type="number"  (keypress)="numberOnly($event)" style="width: 300px" [(ngModel)]="puissanceDe"><br><br>
          <label>Résultat : {{myPuissanceNumber | multiplicatPipe:puissanceDe}} </label>

          <h4>Pipe de la detection de changement</h4>
          <input type="text" #employe (keyup.enter)="ajouterEmploye(employe.value); employe.value=''" style="width: 300px" placeholder="Nom de l'employé"><br>
          
              <div class="custom-control custom-checkbox">
                <input [(ngModel)]="emotion" type="checkbox" class="custom-control-input" id="heureux">
                <label class="custom-control-label" for="heureux">Heureux</label>
              </div>
          
              <button class="btn btn-warning" (click)="reinitialiser()">Reinitialiser</button>
            <h6><b>Tous les employes (no pipe)  :</b></h6> 
              <div *ngFor="let employe of employes">
                Nom: {{employe.nom}} , Emotion: {{employe.emotion}}
            </div>

            <h6><b>employes heureux (pipe PURE PIRE)  :</b></h6> 
              <div *ngFor="let employe of (employes | employeHeureux)">
                Nom: {{employe.nom}} , Emotion{{employe.emotion}}
              </div>

              <h6><b>employes heureux (pipe IMPURE PIRE)  :</b></h6> 
              <div *ngFor="let employe of (employes | employeHeureuxImpure)">
                Nom: {{employe.nom}} , Emotion: {{employe.emotion}}
              </div>
        </div>

        <h4>6- Directives</h4>
        <h6>Directive</h6>
        <div [appColor]="color">Text en hightlight</div>
        <div [appColor]="color">Text en hightlight</div>
        <h4>7- Http Client </h4> 
        <h6>Récupérer la méthode Get Http Client à partir du Serveur</h6>
          <ul>
            <li *ngFor="let employe of listeEmploye">
                {{ employe.id}} {{ employe.nom}} {{employe.prenom}} {{employe.age}} {{employe.emotion}}
              </li>
          </ul>

          <button type="button" class="btn-success" (click)="addEmp()">
            ajouter emp par post
          </button>

          <h6>supprimé Employe</h6>
          <input [(ngModel)]="idemploye" type="text"   style="width: 300px" ><br><br>
          <button type="button" class="btn-success" (click)="deleteEmp()">
              supprimer emp par id
            </button>


            <h6>Modifier Employe</h6>
            <input [(ngModel)]="idemploye" type="text"   style="width: 300px" >
          <button type="button" class="btn-success" (click)="deleteEmp()">
              modifier emp
          </button>

</div>